﻿#region License Information
/* HeuristicLab
 * Copyright (C) 2002-2016 Heuristic and Evolutionary Algorithms Laboratory (HEAL)
 *
 * This file is part of HeuristicLab.
 *
 * HeuristicLab is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * HeuristicLab is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with HeuristicLab. If not, see <http://www.gnu.org/licenses/>.
 */
#endregion

using HeuristicLab.Core;
using HeuristicLab.Persistence;

namespace HeuristicLab.Optimization {
  /// <summary>
  /// Interface to mark operators that can be used as replacers.
  /// Replacers are merging a remaining and a selected branch in several special ways.
  /// </summary>
  [StorableType("2a1f65b0-d19f-4f48-a8d4-23cb6a58e03f")]
  public interface IReplacer : IOperator {
    IValueLookupParameter<ISelector> ReplacedSelectorParameter { get; }
    IValueLookupParameter<ISelector> SelectedSelectorParameter { get; }
  }
}
